diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
index 8504417f2..c80615e7f 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
@@ -140,7 +140,7 @@ public class WorldFeatureTreeCaatinga extends WorldFeature
                     int l3 = k3 - x;
                     for (int i4 = z - i3; i4 <= z + i3; i4++) {
                         int j4 = i4 - z;
-                        if ((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && !Block.solid[world.getBlockId(k3, k1, i4)]) {
+                        if ((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && WorldFeatureTree.canLeavesReplace(world, k3, k1, i4)) {
                             placeLeaves(world, k3+ modX, k1 + modY, i4+ modZ, random);
                         }
                     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
index ab52ab5ad..3f817920c 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
@@ -98,7 +98,7 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
                 for(int i4 = z - i3; i4 <= z + i3; i4++)
                 {
                     int j4 = i4 - z;
-                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && !Block.solid[world.getBlockId(k3, k1, i4)])
+                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && WorldFeatureTree.canLeavesReplace(world, k3, k1, i4))
                     {
                         world.setBlockWithNotify(k3, k1, i4, leavesID);
                         if (treeRand.nextInt(5) == 0)
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
index 19969007d..4f1e981ab 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
@@ -80,7 +80,7 @@ public class WorldFeatureTreeShrub extends WorldFeature
                 for(int i4 = z - i3; i4 <= z + i3; i4++)
                 {
                     int j4 = i4 - z;
-                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0) && !Block.solid[world.getBlockId(k3, k1, i4)])
+                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0) && WorldFeatureTree.canLeavesReplace(world, k3, k1, i4))
                     {
                         if((k3 != x -i3 && k3 != x +i3) || (i4 != z -i3 && i4 != z +i3))
                             world.setBlockWithNotify(k3, k1, i4, leavesID);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
index 69498f366..fde431808 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
@@ -91,7 +91,7 @@ public class WorldFeatureTreeTaigaBushy extends WorldFeature
                 for(int k5 = z - k2; k5 <= z + k2; k5++)
                 {
                     int l5 = k5 - z;
-                    if((Math.abs(j5) != k2 || Math.abs(l5) != k2 || k2 <= 0) && !Block.solid[world.getBlockId(l4, j4, k5)])
+                    if((Math.abs(j5) != k2 || Math.abs(l5) != k2 || k2 <= 0) && WorldFeatureTree.canLeavesReplace(world, l4, j4, k5))
                     {
                         world.setBlockWithNotify(l4, j4, k5, leavesID);
                     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
index a226aed51..d1ddbb3ba 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
@@ -86,7 +86,7 @@ public class WorldFeatureTreeTaigaTall extends WorldFeature
                 for(int l4 = z - k2; l4 <= z + k2; l4++)
                 {
                     int i5 = l4 - z;
-                    if((Math.abs(k4) != k2 || Math.abs(i5) != k2 || k2 <= 0) && !Block.solid[world.getBlockId(l3, i3, l4)])
+                    if((Math.abs(k4) != k2 || Math.abs(i5) != k2 || k2 <= 0) && WorldFeatureTree.canLeavesReplace(world, l3, i3, l4))
                     {
                         world.setBlockWithNotify(l3, i3, l4, leavesID);
                     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
index 7f5e71352..5f1966761 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
@@ -86,7 +86,7 @@ public class WorldFeatureTreeTall extends WorldFeature
                 for(int i4 = z - i3; i4 <= z + i3; i4++)
                 {
                     int j4 = i4 - z;
-                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && !Block.solid[world.getBlockId(k3, k1, i4)])
+                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && WorldFeatureTree.canLeavesReplace(world, k3, k1, i4))
                     {
                         world.setBlockWithNotify(k3, k1, i4, leavesID);
                     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
index 7fabb3cb3..4caefbe22 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 
 import java.util.List;
 import java.util.Random;
@@ -45,7 +46,7 @@ public abstract class WorldFeatureSpoonerTree
 
     protected boolean assignValue(int x, int y, int z, int id, int meta, World world) {
         if (id == leavesId) {
-            if (!Block.solid[world.getBlockId(x, y, z)]) {
+            if (WorldFeatureTree.canLeavesReplace(world, x, y, z)) {
                 return world.setBlockAndMetadataWithNotify(x, y, z, id, meta);
             }
             return false;
diff --git a/src/main/java/net/minecraft/core/world/save/LevelData.java b/src/main/java/net/minecraft/core/world/save/LevelData.java
index 3f1f53b8f..14e4a405f 100644
--- a/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -40,14 +40,15 @@ public class LevelData
         readFromCompoundTag(tag);
     }
 
-    public LevelData(long seed, @NotNull String name)
+    //do *not* add @NotNull to name here, breaks modding for some abstract reason
+    public LevelData(long seed, String name)
     {
         randomSeed = seed;
         levelName = name;
         gameRules = new GameRuleCollection();
     }
 
-    public LevelData(long seed, @NotNull String name, GameRuleCollection gameRules)
+    public LevelData(long seed, String name, GameRuleCollection gameRules)
     {
         randomSeed = seed;
         levelName = name;
diff --git a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
index 4cf409877..4c834ba45 100644
--- a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
+++ b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
@@ -18,6 +18,7 @@ import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.menu.*;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
@@ -724,7 +725,17 @@ public class ServerPlayer extends Player implements ContainerListener {
     	playerNetServerHandler.sendPacket(new SetCarriedItemPacket(i));
     }
 
-	@Override
+    @Override
+    public void setHeldObject(@Nullable ICarriable heldObject) {
+        super.setHeldObject(heldObject);
+        mcServer.getEntityTracker(dimension).sendPacketToTrackedPlayers(this, new SetHeldObjectPacket(id, heldObject));
+
+        // Ensure slot is definitely synced
+        playerNetServerHandler.sendPacket(new SetHotbarOffsetPacket(inventory.getHotbarOffset()));
+        playerNetServerHandler.sendPacket(new SetCarriedItemPacket(inventory.getCurrentItemIndex()));
+    }
+
+    @Override
 	public void sendMessage(String message) {
 		playerNetServerHandler.sendPacket(new ChatPacket(message, 0, AES.keyChain.get(username)));
 	}
diff --git a/src/main/java/net/minecraft/server/net/PlayerList.java b/src/main/java/net/minecraft/server/net/PlayerList.java
index 69c088d56..9db306f4b 100644
--- a/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -107,7 +107,7 @@ public class PlayerList
         playerIo = aworldserver[0].getSaveHandler().getPlayerFileData();
     }
 
-    public void func_28172_a(ServerPlayer player)
+    public void syncPlayerDimension(ServerPlayer player)
     {
         for (PlayerManager playerManager : playerManagers) {
             playerManager.removePlayer(player);
@@ -291,7 +291,7 @@ public class PlayerList
                 worldserver1.chunkProviderServer.chunkLoadOverride = false;
             }
         }
-        func_28172_a(serverPlayer);
+        syncPlayerDimension(serverPlayer);
         serverPlayer.playerNetServerHandler.teleportAndRotate(serverPlayer.x, serverPlayer.y, serverPlayer.z, serverPlayer.yRot, serverPlayer.xRot);
         server.playerList.sendPacketToAllPlayers(new PlayerGamemodePacket(serverPlayer.id, serverPlayer.gamemode.getId()));
         serverPlayer.setWorld(worldserver1);
diff --git a/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
index 0429c77f2..192eed88d 100644
--- a/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
@@ -213,6 +213,9 @@ public class LoginPacketHandler extends PacketHandler
             player.playerNetServerHandler.sendPacket(new PhotoModePacket(mcServer.disablePhotoMode));
             player.playerNetServerHandler.sendPacket(new GameRulePacket(mcServer.getDimensionWorld(0).getLevelData().getGameRules()));
             player.playerNetServerHandler.sendPacket(new CommandManagerPacket(this.mcServer.getDimensionWorld(player.dimension).getCommandManager().getDispatcher(), new ServerCommandSource(this.mcServer, player), "", 0));
+            player.playerNetServerHandler.sendPacket(new SetHeldObjectPacket(player.id, player.getHeldObject()));
+            player.playerNetServerHandler.sendPacket(new SetHotbarOffsetPacket(player.inventory.getHotbarOffset()));
+            player.playerNetServerHandler.sendPacket(new SetCarriedItemPacket(player.inventory.getCurrentItemIndex()));
 
             for (RecipeEntryBase<?, ?, ?> recipe : Registries.RECIPES.getAllSerializableRecipes()) {
                 player.playerNetServerHandler.sendPacket(new RecipeSyncPacket(recipe,Registries.RECIPES.getAllSerializableRecipes().size()));
diff --git a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
index 471820fca..c698a8480 100644
--- a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
@@ -247,7 +247,7 @@ public class ServerPacketHandler extends PacketHandler
                 LOGGER.warn("Expected {}, {}, {}", playerEntity.x, playerEntity.y, playerEntity.z);
             }
             playerEntity.absMoveTo(newPosX, newPosY, newPosZ, f2, f3);
-            boolean flag2 = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(f4, f4, f4)).size() == 0;
+            boolean flag2 = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(f4, f4, f4)).isEmpty();
             if (!playerEntity.getGamemode().canPlayerFly() && flag && (flag1 || !flag2) && !playerEntity.isPlayerSleeping())
             {
                 teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
@@ -304,7 +304,7 @@ public class ServerPacketHandler extends PacketHandler
         final int y = packet.yPosition;
         final int z = packet.zPosition;
 
-        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
+        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive() || playerEntity.getHeldObject() != null /*Forbid digging while holding object*/) return;
         WorldServer world = mcServer.getDimensionWorld(playerEntity.dimension);
         if(packet.status == 4) {
             // Drop single item
@@ -378,7 +378,7 @@ public class ServerPacketHandler extends PacketHandler
             {
                 return;
             }
-            playerEntity.playerController.func_6154_a(playerEntity, worldserver, itemstack);
+            playerEntity.playerController.useItemOnNothing(playerEntity, worldserver, itemstack);
         }
         else
         {
@@ -408,11 +408,11 @@ public class ServerPacketHandler extends PacketHandler
         itemstack = playerEntity.inventory.getCurrentItem();
         if (itemstack != null && itemstack.stackSize <= 0)
         {
-            playerEntity.inventory.mainInventory[playerEntity.inventory.currentItem] = null;
+            playerEntity.inventory.mainInventory[playerEntity.inventory.getCurrentItemIndex()] = null;
         }
         playerEntity.isChangingQuantityOnly = true;
-        playerEntity.inventory.mainInventory[playerEntity.inventory.currentItem] = ItemStack.copyItemStack(playerEntity.inventory.mainInventory[playerEntity.inventory.currentItem]);
-        Slot slot = playerEntity.craftingInventory.getSlotFor(playerEntity.inventory, playerEntity.inventory.currentItem);
+        playerEntity.inventory.mainInventory[playerEntity.inventory.getCurrentItemIndex()] = ItemStack.copyItemStack(playerEntity.inventory.mainInventory[playerEntity.inventory.getCurrentItemIndex()]);
+        Slot slot = playerEntity.craftingInventory.getSlotFor(playerEntity.inventory, playerEntity.inventory.getCurrentItemIndex());
         playerEntity.craftingInventory.broadcastChanges();
         playerEntity.isChangingQuantityOnly = false;
         if (!ItemStack.areItemStacksEqual(playerEntity.inventory.getCurrentItem(), packet.itemStack))
@@ -440,7 +440,7 @@ public class ServerPacketHandler extends PacketHandler
     @Override
     public void handleInvalidPacket(Packet packet)
     {
-        LOGGER.warn(getClass() + " wasn't prepared to deal with a " + packet.getClass());
+        LOGGER.warn("{} wasn't prepared to deal with a {}", getClass(), packet.getClass());
         kickPlayer("Protocol error, unexpected packet");
     }
 
@@ -455,12 +455,15 @@ public class ServerPacketHandler extends PacketHandler
     {
         if (packet.id < 0 || packet.id > Inventory.func_25054_e())
         {
-            LOGGER.warn(playerEntity.username + " tried to set an invalid carried item");
+            LOGGER.warn("{} tried to set an invalid carried item", playerEntity.username);
             return;
         }
         else
         {
-            playerEntity.inventory.currentItem = packet.id;
+            playerEntity.inventory.setCurrentItemIndex(packet.id, false);
+            if (packet.id != playerEntity.inventory.getCurrentItemIndex()) { // If client tried to set current item while locked then send a packet back attempting to resync them
+                sendPacket(new SetCarriedItemPacket(packet.id));
+            }
             return;
         }
     }
@@ -579,7 +582,7 @@ public class ServerPacketHandler extends PacketHandler
     @Override
     public void handleUseEntity(InteractPacket packet)
     {
-        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
+        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive() || playerEntity.getHeldObject() != null /*TODO consider adding entity interactions while holding object*/) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
         Entity targetEntity = worldserver.getEntityFromId(packet.targetEntityID);
         if (targetEntity != null && playerEntity.distanceToSqr(targetEntity) < 36D)
@@ -753,7 +756,11 @@ public class ServerPacketHandler extends PacketHandler
     @Override
     public void handleSetHotbarOffset(SetHotbarOffsetPacket packet)
     {
-        playerEntity.inventory.hotbarOffset = packet.hotbarOffset;
+
+        playerEntity.inventory.setHotbarOffset(packet.hotbarOffset, false);
+        if (packet.hotbarOffset != playerEntity.inventory.getHotbarOffset()) { // If player tries to set hotbar offset while locked resync the clients offset
+            sendPacket(new SetHotbarOffsetPacket(packet.hotbarOffset));
+        }
     }
     
     @Override
diff --git a/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index 56ee1b149..7bfd0f723 100644
--- a/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -145,17 +145,17 @@ public class ServerPlayerController
         return flag;
     }
 
-    public boolean func_6154_a(Player entityplayer, World world, ItemStack itemstack)
+    public boolean useItemOnNothing(Player entityplayer, World world, ItemStack itemstack)
     {
         if (!entityplayer.getGamemode().canInteract()) return false;
         int i = itemstack.stackSize;
         ItemStack itemstack1 = itemstack.useItemRightClick(world, entityplayer);
         if(itemstack1 != itemstack || itemstack1 != null && itemstack1.stackSize != i)
         {
-            entityplayer.inventory.mainInventory[entityplayer.inventory.currentItem] = itemstack1;
+            entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentItemIndex()] = itemstack1;
             if(itemstack1.stackSize <= 0)
             {
-                entityplayer.inventory.mainInventory[entityplayer.inventory.currentItem] = null;
+                entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentItemIndex()] = null;
             }
             return true;
         } else
@@ -164,24 +164,39 @@ public class ServerPlayerController
         }
     }
 
-    public boolean activateBlockOrUseItem(Player entityplayer, World world, ItemStack itemstack, int i, int j, int k, Side side, double xPlaced, double yPlaced)
+    public boolean activateBlockOrUseItem(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         if (!entityplayer.getGamemode().canInteract()) return false;
-        int i1 = world.getBlockId(i, j, k);
-        if ((entityplayer.isSneaking() && entityplayer.getCurrentEquippedItem() == null) || (!entityplayer.isSneaking()))
-        {
-            if (i1 > 0 && Block.blocksList[i1].onBlockRightClicked(world, i, j, k, entityplayer, side, xPlaced, yPlaced))
-            {
-                return true;
+        int blockId = world.getBlockId(blockX, blockY, blockZ);
+        if (player.getHeldObject() == null) {
+            if (player.isSneaking() && itemstack == null) { // If crouched and hand empty try to pickup block entity
+                BlockEntity blockEntity = world.getBlockEntity(blockX, blockY, blockZ);
+                if (blockEntity != null && blockEntity.canBeCarried(world, player)) {
+                    player.setHeldObject(blockEntity.pickup(world, player));
+                    return true;
+                }
             }
-        }
-        if(itemstack == null)
-        {
-            return false;
-        }
-        else
-        {
-            return itemstack.useItem(entityplayer, world, i, j, k, side, xPlaced, yPlaced);
+            if (!player.isSneaking() || itemstack == null) {  // If standing or hand empty perform block right click method
+                if (blockId > 0 && Block.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
+                    return true;
+                }
+            }
+            if (itemstack == null) { // No stack do nothing
+                return false;
+            } else { // Use itemstack
+                return itemstack.useItem(player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+            }
+        } else {
+            if (!player.isSneaking()) {  // If standing or hand empty perform block right click method
+                if (blockId > 0 && Block.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
+                    return true;
+                }
+            }
+            boolean didPlace = player.getHeldObject().tryPlace(world, player, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+            if (didPlace) {
+                player.setHeldObject(null);
+            }
+            return didPlace;
         }
     }
 
